hdu-1010

Tempter of the Bone

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 93682    Accepted Submission(s): 25438


Problem Description
The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.
 

Input
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

'X': a block of wall, which the doggie cannot enter; 
'S': the start point of the doggie; 
'D': the Door; or
'.': an empty block.

The input is terminated with three 0's. This test case is not to be processed.
 

Output
For each test case, print in one line "YES" if the doggie can survive, or "NO" otherwise.
 

Sample Input
  
  
4 4 5 S.X. ..X. ..XD .... 3 4 5 S.X. ..X. ...D 0 0 0
 

Sample Output
  
  
NO YES
题目来源: http://acm.hdu.edu.cn/showproblem.php?pid=1010
考查知识点: dfs+剪枝
解体思路:如果老是wa的同学注意了把输入函数换成就能过了,我就是这样,这里感觉有点坑......如果是超时,那么就是没有剪枝.
主要的剪枝条件:
(1) 当能够走的路小于剩下的时间
(2) 奇偶剪枝
(3) 数组越界
(4) 已走过或不能通
较难理解的就是奇偶剪枝
解释如下:

若有一迷宫,将迷宫的每一个位置有0或1表示(x+y为偶数时为0 否则为1):

0   1    0    1   0

1   0    1    0   1

0   1    0    1   0

1   0    1    0   1

 

从图中我们可以很清晰的看出:任意一个位置周围相邻的必然是与本身值相反的值,也就是说,要想走到与本身值相同的点必然要走偶数步;

同理,要想走到与本身相异的值的点必然要走奇数步;

所以,当两个位置的奇偶性相同时(同为0或同为1)若时间为奇数  则必然无法到达;当两个位置的奇偶性不同时(一个为1,另一个为0)若时间为偶数也必不能到达。

另temp=剩下时间-两者距离.当结果>0时

偶数-偶数=偶数( 当两个位置的奇偶性相同时)
奇数-奇数=偶数( 当两个位置的奇偶性不同时)
所以temp不能为奇数
代码如下:
#include<stdio.h>
#include<string.h>
#include<cmath>
#include<iostream>
using namespace std;
int n,m,t;
int flag,fx,fy;
char mark[10][10];
int vist[10][10];
void  dfs(int x,int y,int c)
{
	int temp;
	if(x<0||y<0||x>=n||y>=m||vist[x][y]||mark[x][y]=='X')
	return;
	if(flag==1)return;
	if(x==fx&&y==fy&&c==t)
	{
		flag=1;
		return;
	}
	temp=(t-c)-fabs(x-fx)-fabs(y-fy);
	if(temp<0||temp%2)
	return;
	vist[x][y]=1;
	dfs(x-1,y,c+1);
	dfs(x+1,y,c+1);
	dfs(x,y+1,c+1);
	dfs(x,y-1,c+1);
	vist[x][y]=0;
}
int main()
{
	int x,y,wall;
	while(scanf("%d%d%d",&n,&m,&t))
	{
		if(n==0&&m==0&&t==0)break;
		wall=0;
		for(int i=0;i<n;i++)
		{
			getchar();
			for(int j=0;j<m;j++)
			{
				//scanf("%c",&mark[i][j]);
				cin>>mark[i][j];
				if(mark[i][j]=='S')
				{
	                 x=i;y=j;				
				}
				else if(mark[i][j]=='D')
				{
					fx=i;fy=j;
				}
				else if(mark[i][j]=='X')
				wall++;
			}
			
		}
		if(n*m-wall<=t)
		{
			//printf("NO\n");
			cout<<"NO\n";
			continue;
		}//搜索前优化 
//		for(int i=0;i<n;i++)
//		printf("%s\n",mark[i]);
	       flag=0;
		   memset(vist,0,sizeof(vist));
		   //vist[x][y]=1;
		dfs(x,y,0);
		if(flag)
	//	printf("YES\n");
	cout<<"YES\n";
	
		else //printf("NO\n");
		cout<<"NO\n";
		
	}
	return 0;
}





 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值